/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003-2004  Ciaran Anscomb
 *
 *  See COPYING for redistribution conditions. */

#ifndef __FS_H__
#define __FS_H__

#include "types.h"

#ifdef GP32
# include "fs_gp32.h"
#else
# include "fs_unix.h"
#endif

#define FS_READ 0x01
#define FS_WRITE 0x02

void fs_init(void);

FS_FILE fs_open(char *filename, int flags);
int fs_read(FS_FILE fd, void *buffer, Uint32 size);
int fs_write(FS_FILE fd, void *buffer, Uint32 size);
void fs_close(FS_FILE fd);

int fs_load_file(char *filename, void *buf, int size);
int fs_write_byte(FS_FILE fd, Uint8 octet);
int fs_write_word16(FS_FILE fd, Uint16 word16);
int fs_write_word32(FS_FILE fd, Uint32 word32);
int fs_read_byte(FS_FILE fd, Uint8 *dest);
int fs_read_word16(FS_FILE fd, Uint16 *dest);
int fs_read_word32(FS_FILE fd, Uint32 *dest);

#endif  /* __FS_H__ */
