/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003-2004  Ciaran Anscomb
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdlib.h>

#include "video.h"
#include "types.h"

static PIXEL backup[320*240];

SDL_Surface *screen;

void video_init(void) {
	screen = SDL_SetVideoMode(320, 240, 8, SDL_SWSURFACE);
	if (screen == NULL) {
		exit(1);
	}
	video_fillrect(0,0,320,240,MAPCOLOUR(0,0,0));
}

void video_fillrect(Uint32 x, Uint32 y, Uint32 w, Uint32 h, PIXEL colour) {
	PIXEL *p1 = VIDEO_SCREENBASE + (239 - y) * 320 + x;
	int skip = -320 - w;
	Uint32 i;
	for (; h; h--) {
		for (i = w; i; i--) {
			*(p1++) = colour;
		}
		p1 += skip;
	}
}

void video_blit(Uint32 x, Uint32 y, PIXEL *src, Uint32 w, Uint32 h) { }

void video_backup(void) {
	memcpy(backup, VIDEO_SCREENBASE, 320*240*sizeof(PIXEL));
}

void video_restore(void) {
	memcpy(VIDEO_SCREENBASE, backup, 320*240*sizeof(PIXEL));
}
